Index: branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/PackingPlan2D.cs
===================================================================
--- branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/PackingPlan2D.cs	(revision 13161)
+++ branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/PackingPlan2D.cs	(revision 13465)
@@ -33,12 +33,12 @@
 namespace PackingPlanVisualizations {
   public partial class PackingPlan2D : UserControl {
-    WindowRenderTarget wndRender              = null;
-    Factory2D1 factory                        = new Factory2D1(FactoryType2D1.SingleThreaded);
-    SharpDX.DirectWrite.Factory dwFactory     = new SharpDX.DirectWrite.Factory(SharpDX.DirectWrite.FactoryType.Shared);
-    RenderTargetProperties rndTargProperties  = new RenderTargetProperties(new PixelFormat(Format.B8G8R8A8_UNorm, AlphaMode.Premultiplied));
+    WindowRenderTarget wndRender = null;
+    Factory2D1 factory = new Factory2D1(FactoryType2D1.SingleThreaded);
+    SharpDX.DirectWrite.Factory dwFactory = new SharpDX.DirectWrite.Factory(SharpDX.DirectWrite.FactoryType.Shared);
+    RenderTargetProperties rndTargProperties = new RenderTargetProperties(new PixelFormat(Format.B8G8R8A8_UNorm, AlphaMode.Premultiplied));
     HwndRenderTargetProperties hwndProperties = new HwndRenderTargetProperties();
 
 
-    #region Packing members BEGIN     
+    #region Packing members BEGIN
     SolidColorBrush containerBrush;
     SolidColorBrush containerFillingBrush;
@@ -71,5 +71,5 @@
       containerFillingBrush = new SolidColorBrush(wndRender, Colors.DarkGray);
       itemBrush = new SolidColorBrush(wndRender, Colors.Black);
-      itemFillingBrush = new SolidColorBrush(wndRender, new Color4 (Color3.White, 0.5f));
+      itemFillingBrush = new SolidColorBrush(wndRender, new Color4(Color3.White, 0.5f));
       labelBrush = new SolidColorBrush(wndRender, Colors.Black);
     }
@@ -80,18 +80,13 @@
 
     //Packing-Methods
-    public void InitializeContainer (float width, float height) {
-      container = new CenteredContainer2D(new Vector2 (this.Width, this.Height), new Vector2 (width, height));   
+    public void InitializeContainer(float width, float height) {
+      container = new CenteredContainer2D(new Vector2(this.Width, this.Height), new Vector2(width, height));
     }
 
     public void AddItemToContainer(float width, float height, float x, float y, string label) {
-      container.AddItem(new Vector2(width, height), new Vector2 (x, y), label);
+      container.AddItem(new Vector2(width, height), new Vector2(x, y), label);
     }
 
-
-
-    
-
-
-    //Event-Listeners  
+    //Event-Listeners
 
     private void PackingPlan2D_Load(object sender, EventArgs e) {
@@ -101,17 +96,10 @@
     private void PackingPlan2D_Paint(object sender, PaintEventArgs e) {
       wndRender.BeginDraw();
-      var controlColor = Colors.White;//System.Drawing.SystemColors.Control;
-      wndRender.Clear(new Colors (controlColor.R, controlColor.G, controlColor.B));
+      var controlColor = Colors.White;
+      wndRender.Clear(new Colors(controlColor.R, controlColor.G, controlColor.B));
 
       if (container != null) {
         container.UpdateContainer(new Vector2(this.Width, this.Height));
         wndRender.FillRectangle(container.GetContainerData(), containerFillingBrush);
-
-        //foreach (PackingPlanVisualizations.CenteredContainer2D.PackingItem item in container.GetPackingItems()) {
-        //  SharpDX.RectangleF rect = item.GetRectangle(container.ContainerTopLeft);
-        //  wndRender.DrawRectangle(rect, itemBrush, 2f);
-        //  wndRender.FillRectangle(rect, itemFillingBrush);
-        //  wndRender.DrawText(item.GetLabel(), textFormat, rect, labelBrush);
-        //}
 
         foreach (PackingPlanVisualizations.CenteredContainer2D.LabeledRectangle item in container.GetItemRectangles()) {
@@ -131,5 +119,4 @@
       if (wndRender != null)
         wndRender.Resize(new Size2(this.Width, this.Height));
-      //this.Refresh();
     }
 
Index: branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/PackingPlan2D.resx
===================================================================
--- branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/PackingPlan2D.resx	(revision 13161)
+++ 	(revision )
@@ -1,120 +1,0 @@
-﻿<?xml version="1.0" encoding="utf-8"?>
-<root>
-  <!-- 
-    Microsoft ResX Schema 
-    
-    Version 2.0
-    
-    The primary goals of this format is to allow a simple XML format 
-    that is mostly human readable. The generation and parsing of the 
-    various data types are done through the TypeConverter classes 
-    associated with the data types.
-    
-    Example:
-    
-    ... ado.net/XML headers & schema ...
-    <resheader name="resmimetype">text/microsoft-resx</resheader>
-    <resheader name="version">2.0</resheader>
-    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
-    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
-    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
-    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
-    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
-        <value>[base64 mime encoded serialized .NET Framework object]</value>
-    </data>
-    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
-        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
-        <comment>This is a comment</comment>
-    </data>
-                
-    There are any number of "resheader" rows that contain simple 
-    name/value pairs.
-    
-    Each data row contains a name, and value. The row also contains a 
-    type or mimetype. Type corresponds to a .NET class that support 
-    text/value conversion through the TypeConverter architecture. 
-    Classes that don't support this are serialized and stored with the 
-    mimetype set.
-    
-    The mimetype is used for serialized objects, and tells the 
-    ResXResourceReader how to depersist the object. This is currently not 
-    extensible. For a given mimetype the value must be set accordingly:
-    
-    Note - application/x-microsoft.net.object.binary.base64 is the format 
-    that the ResXResourceWriter will generate, however the reader can 
-    read any of the formats listed below.
-    
-    mimetype: application/x-microsoft.net.object.binary.base64
-    value   : The object must be serialized with 
-            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
-            : and then encoded with base64 encoding.
-    
-    mimetype: application/x-microsoft.net.object.soap.base64
-    value   : The object must be serialized with 
-            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
-            : and then encoded with base64 encoding.
-
-    mimetype: application/x-microsoft.net.object.bytearray.base64
-    value   : The object must be serialized into a byte array 
-            : using a System.ComponentModel.TypeConverter
-            : and then encoded with base64 encoding.
-    -->
-  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
-    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
-    <xsd:element name="root" msdata:IsDataSet="true">
-      <xsd:complexType>
-        <xsd:choice maxOccurs="unbounded">
-          <xsd:element name="metadata">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" />
-              </xsd:sequence>
-              <xsd:attribute name="name" use="required" type="xsd:string" />
-              <xsd:attribute name="type" type="xsd:string" />
-              <xsd:attribute name="mimetype" type="xsd:string" />
-              <xsd:attribute ref="xml:space" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="assembly">
-            <xsd:complexType>
-              <xsd:attribute name="alias" type="xsd:string" />
-              <xsd:attribute name="name" type="xsd:string" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="data">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
-                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
-              </xsd:sequence>
-              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
-              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
-              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
-              <xsd:attribute ref="xml:space" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="resheader">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
-              </xsd:sequence>
-              <xsd:attribute name="name" type="xsd:string" use="required" />
-            </xsd:complexType>
-          </xsd:element>
-        </xsd:choice>
-      </xsd:complexType>
-    </xsd:element>
-  </xsd:schema>
-  <resheader name="resmimetype">
-    <value>text/microsoft-resx</value>
-  </resheader>
-  <resheader name="version">
-    <value>2.0</value>
-  </resheader>
-  <resheader name="reader">
-    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-  <resheader name="writer">
-    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-</root>
Index: branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/BasicCuboidShape.cs
===================================================================
--- branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/BasicCuboidShape.cs	(revision 13161)
+++ branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/BasicCuboidShape.cs	(revision 13465)
@@ -25,24 +25,24 @@
 
 namespace PackingPlanVisualizations {
-  
+
   public class BasicCuboidShape {
     //Basic information
-    private Vector3 shapeSize;
+    private readonly Vector3 shapeSize;
     public Vector3 ShapeSize { get { return shapeSize; } }
-    private Vector3 shapePosition;
+    private readonly Vector3 shapePosition;
     public Vector3 ShapePosition { get { return shapePosition; } }
-    private int shapeID;
+    private readonly int shapeID;
     public int ShapeID { get { return shapeID; } }
     public int Material { get; set; }
 
 
-    //Vertices                                       
+    //Vertices
     private VertexPositionColorNormal[] shapeTriangleVertices;
     private VertexPositionColorNormal[] shapeLineVertices;
 
     public BasicCuboidShape(Vector3 size, Vector3 position, int shapeNr, int material) {
-      shapeSize       = size;
-      shapePosition   = position;
-      shapeID     = shapeNr;
+      shapeSize = size;
+      shapePosition = position;
+      shapeID = shapeNr;
       this.Material = material;
     }
@@ -65,5 +65,5 @@
 
     public void RenderShapeTriangles(GraphicsDevice device) {
-      RenderShapeTriangles(device, Material == 0 ? new Color(60,60,60) :new Color (0,0,0));
+      RenderShapeTriangles(device, Material == 0 ? new Color(60, 60, 60) : new Color(0, 0, 0));
     }
 
@@ -85,7 +85,6 @@
     }
 
-    public Vector3 CalculatePositionRelativeToBottomLeftBackCorner(Vector3 itemSize, Vector3 itemPosition) {     
-      //Vector3 bottomLeftBack = shapePosition + new Vector3(-1.0f, -1.0f, 1.0f) * shapeSize;
-      Vector3 newPosition = itemPosition - (shapeSize/2 - itemSize/2);
+    public Vector3 CalculatePositionRelativeToBottomLeftBackCorner(Vector3 itemSize, Vector3 itemPosition) {
+      Vector3 newPosition = itemPosition - (shapeSize / 2 - itemSize / 2);
       return newPosition;
     }
Index: branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/CenteredContainer.cs
===================================================================
--- branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/CenteredContainer.cs	(revision 13161)
+++ branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/CenteredContainer.cs	(revision 13465)
@@ -27,7 +27,7 @@
 
   public class CenteredContainer {
-    private  BasicCuboidShape container;
-    private  List<BasicCuboidShape> packingItems;
-    private float normalizingFactor;
+    private readonly BasicCuboidShape container;
+    private readonly List<BasicCuboidShape> packingItems;
+    private readonly float normalizingFactor;
 
     public CenteredContainer(BasicCuboidShape container) {
@@ -58,10 +58,4 @@
       Vector3 itemSize = size * normalizingFactor;
       Vector3 itemPosition = position * normalizingFactor;
-      //Apply rotation = swap X and Y size
-      //if (rotated) {
-      //  float aux = itemSize.X;
-      //  itemSize.X = itemSize.Y;
-      //  itemSize.Y = aux;
-      //}
       Vector3 actualPosition = container.CalculatePositionRelativeToBottomLeftBackCorner(itemSize, itemPosition);
       BasicCuboidShape itemShape = new BasicCuboidShape(itemSize, actualPosition, index, material); 
Index: branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/CuboidShapePreperations.cs
===================================================================
--- branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/CuboidShapePreperations.cs	(revision 13161)
+++ branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/CuboidShapePreperations.cs	(revision 13465)
@@ -53,9 +53,4 @@
     Color rightColor = Color.Black;
 
-    //Define positions of the textures
-    Vector2 textureTopLeft;
-    Vector2 textureTopRight;
-    Vector2 textureBottomLeft;
-    Vector2 textureBottomRight;
     #endregion Private Members
 
@@ -91,9 +86,4 @@
       rightColor = color;
 
-      //Define positions of the textures
-      textureTopLeft = new Vector2(0.5f * halfShapeSize.X, 0.0f * halfShapeSize.Y);
-      textureTopRight = new Vector2(0.0f * halfShapeSize.X, 0.0f * halfShapeSize.Y);
-      textureBottomLeft = new Vector2(0.5f * halfShapeSize.X, 0.5f * halfShapeSize.Y);
-      textureBottomRight = new Vector2(0.0f * halfShapeSize.X, 0.5f * halfShapeSize.Y);
     }
 
@@ -171,58 +161,4 @@
       //Definition of the actual lines
       VertexPositionColorNormal[] shapeVertices = new VertexPositionColorNormal[48];
-
-      //shapeVertices[0] = new VertexPositionColorNormal(color, topRightFront, frontNormal);
-      //shapeVertices[1] = new VertexPositionColorNormal(color, topLeftFront, frontNormal);
-      //shapeVertices[2] = new VertexPositionColorNormal(color, topLeftFront, frontNormal);
-      //shapeVertices[3] = new VertexPositionColorNormal(color, bottomLeftFront, frontNormal);
-      //shapeVertices[4] = new VertexPositionColorNormal(color, bottomLeftFront, frontNormal);
-      //shapeVertices[5] = new VertexPositionColorNormal(color, bottomRightFront, frontNormal);
-      //shapeVertices[6] = new VertexPositionColorNormal(color, bottomRightFront, frontNormal);
-      //shapeVertices[7] = new VertexPositionColorNormal(color, topRightFront, frontNormal);
-
-      //shapeVertices[8] = new VertexPositionColorNormal(color, topRightBack, backNormal);
-      //shapeVertices[9] = new VertexPositionColorNormal(color, topLeftBack, backNormal);
-      //shapeVertices[10] = new VertexPositionColorNormal(color, topLeftBack, backNormal);
-      //shapeVertices[11] = new VertexPositionColorNormal(color, bottomLeftBack, backNormal);
-      //shapeVertices[12] = new VertexPositionColorNormal(color, bottomLeftBack, backNormal);
-      //shapeVertices[13] = new VertexPositionColorNormal(color, bottomRightBack, backNormal);
-      //shapeVertices[14] = new VertexPositionColorNormal(color, bottomRightBack, backNormal);
-      //shapeVertices[15] = new VertexPositionColorNormal(color, topRightBack, backNormal);
-
-      //shapeVertices[16] = new VertexPositionColorNormal(color, topLeftFront, topNormal);
-      //shapeVertices[17] = new VertexPositionColorNormal(color, topLeftBack, topNormal);
-      //shapeVertices[18] = new VertexPositionColorNormal(color, topRightFront, topNormal);
-      //shapeVertices[19] = new VertexPositionColorNormal(color, topRightBack, topNormal);
-      //shapeVertices[20] = new VertexPositionColorNormal(color, topLeftFront, topNormal);
-      //shapeVertices[21] = new VertexPositionColorNormal(color, topRightFront, topNormal);
-      //shapeVertices[22] = new VertexPositionColorNormal(color, topRightBack, topNormal);
-      //shapeVertices[23] = new VertexPositionColorNormal(color, topLeftBack, topNormal);
-
-      //shapeVertices[24] = new VertexPositionColorNormal(color, bottomLeftFront, bottomNormal);
-      //shapeVertices[25] = new VertexPositionColorNormal(color, bottomRightFront, bottomNormal);
-      //shapeVertices[26] = new VertexPositionColorNormal(color, bottomLeftBack, bottomNormal);
-      //shapeVertices[27] = new VertexPositionColorNormal(color, bottomRightBack, bottomNormal);
-      //shapeVertices[28] = new VertexPositionColorNormal(color, bottomRightFront, bottomNormal);
-      //shapeVertices[29] = new VertexPositionColorNormal(color, bottomRightBack, bottomNormal);
-      //shapeVertices[30] = new VertexPositionColorNormal(color, bottomLeftFront, bottomNormal);
-      //shapeVertices[31] = new VertexPositionColorNormal(color, bottomLeftBack, bottomNormal);
-
-      //shapeVertices[32] = new VertexPositionColorNormal(color, topLeftFront, leftNormal);
-      //shapeVertices[33] = new VertexPositionColorNormal(color, topLeftBack, leftNormal);
-      //shapeVertices[34] = new VertexPositionColorNormal(color, topLeftBack, leftNormal);
-      //shapeVertices[35] = new VertexPositionColorNormal(color, bottomLeftBack, leftNormal);
-      //shapeVertices[36] = new VertexPositionColorNormal(color, bottomLeftBack, leftNormal);
-      //shapeVertices[37] = new VertexPositionColorNormal(color, bottomLeftFront, leftNormal);
-      //shapeVertices[38] = new VertexPositionColorNormal(color, bottomLeftFront, leftNormal);
-      //shapeVertices[39] = new VertexPositionColorNormal(color, topLeftFront, leftNormal);
-
-      //shapeVertices[40] = new VertexPositionColorNormal(color, topRightFront, rightNormal);
-      //shapeVertices[41] = new VertexPositionColorNormal(color, topRightBack, rightNormal);
-      //shapeVertices[42] = new VertexPositionColorNormal(color, topRightBack, rightNormal);
-      //shapeVertices[43] = new VertexPositionColorNormal(color, bottomRightBack, rightNormal);
-      //shapeVertices[44] = new VertexPositionColorNormal(color, bottomRightBack, rightNormal);
-      //shapeVertices[45] = new VertexPositionColorNormal(color, bottomRightFront, rightNormal);
-      //shapeVertices[46] = new VertexPositionColorNormal(color, bottomRightFront, rightNormal);
-      //shapeVertices[47] = new VertexPositionColorNormal(color, topRightFront, rightNormal);
 
       Vector3 topRightFrontNormal = (topNormal + rightNormal + frontNormal) / 3;
Index: branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/PackingGame.cs
===================================================================
--- branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/PackingGame.cs	(revision 13161)
+++ branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/PackingGame.cs	(revision 13465)
@@ -106,8 +106,4 @@
       Console.WriteLine("Initial bounds:" + Window.ClientBounds);
       this.Window.IsMouseVisible = true;
-      //this.Window.ClientSizeChanged += (a, b) => { 
-      //  Console.WriteLine("Resized..");
-      //  this.Tick();
-      //};
     }
     private void initializeWorld() {
@@ -177,8 +173,4 @@
 
       #region Transparency
-
-      //basicEffect.GraphicsDevice.RenderState.AlphaBlendEnable = true;
-      //basicEffect.GraphicsDevice.RenderState.SourceBlend = Blend.SourceAlpha;
-      //basicEffect.GraphicsDevice.RenderState.DestinationBlend = Blend.InverseSourceAlpha;   
 
       BlendStateDescription blendStateDescription = new SharpDX.Direct3D11.BlendStateDescription();
@@ -264,30 +256,28 @@
     private void computeLeftMouseBtnHandling(MouseState mouseState) {
       //Left btn released
-      if (mouseState.LeftButton.Released && mouseState.LeftButton.Equals(previousMouseState.LeftButton)) {
-        //Console.WriteLine("Released");
-      }
+      //if (mouseState.LeftButton.Released && mouseState.LeftButton.Equals(previousMouseState.LeftButton)) {
+      //  //Console.WriteLine("Released");
+      //} else
 
       //Left btn pressed
-      else if (mouseState.LeftButton.Pressed && mouseState.LeftButton.Equals(previousMouseState.LeftButton)) {
+
+      if (mouseState.LeftButton.Pressed && mouseState.LeftButton.Equals(previousMouseState.LeftButton)) {
         currentViewAngle = new Vector2(
           viewAngleOnBtnRelease.X + mouseState.X - mousePositionOnBtnDown.X,
           viewAngleOnBtnRelease.Y + mouseState.Y - mousePositionOnBtnDown.Y);
 
-        //angle += 0.5f;
-        //Console.WriteLine("Pressed");
-        //Console.WriteLine(currentViewAngle.ToString());
       }
 
       //Left btn freshly pressed ==> ONLICK-EVENT
       else if (mouseState.LeftButton.Pressed && !previousMouseState.LeftButton.Pressed) {
-        Console.WriteLine("OnClick");
-        PackingPlan3D native = (PackingPlan3D)Window.NativeWindow;
-        Console.WriteLine("Window: " + Window.ClientBounds.ToString());
-        Console.WriteLine("native: " + native.ClientSize.ToString());
-        Console.WriteLine("native.parent: " + native.Parent.ClientSize.ToString());
-
-        Console.WriteLine(native.ParentForm.ToString());
-        Console.WriteLine(Window.Name);
-        Console.WriteLine(this.IsActive);
+        //Console.WriteLine("OnClick");
+        //PackingPlan3D native = (PackingPlan3D)Window.NativeWindow;
+        //Console.WriteLine("Window: " + Window.ClientBounds.ToString());
+        //Console.WriteLine("native: " + native.ClientSize.ToString());
+        //Console.WriteLine("native.parent: " + native.Parent.ClientSize.ToString());
+        //
+        //Console.WriteLine(native.ParentForm.ToString());
+        //Console.WriteLine(Window.Name);
+        //Console.WriteLine(this.IsActive);
         mousePositionOnBtnDown = new Vector2(mouseState.X, mouseState.Y);
       }
@@ -295,5 +285,5 @@
       //Left btn freshly released ==> ONRELEASE-EVENT
       else if (mouseState.LeftButton.Released && !previousMouseState.LeftButton.Released) {
-        Console.WriteLine("OnRelease");
+        //Console.WriteLine("OnRelease");
         viewAngleOnBtnRelease = currentViewAngle;
       }
@@ -304,8 +294,8 @@
       if (curr < prev && zoom > 1) {
         zoom++;
-        Console.WriteLine(zoom);
+        //Console.WriteLine(zoom);
       } else if (curr > prev && zoom < 300) {
         zoom--;
-        Console.WriteLine(zoom);
+        //Console.WriteLine(zoom);
       }
     }
Index: branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/PackingPlan3D.cs
===================================================================
--- branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/PackingPlan3D.cs	(revision 13161)
+++ branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/PackingPlan3D.cs	(revision 13465)
@@ -25,5 +25,5 @@
 
 
-namespace PackingPlanVisualizations { 
+namespace PackingPlanVisualizations {
   public partial class PackingPlan3D : UserControl {
     private PackingGame game;
@@ -67,21 +67,4 @@
 
 
-
-    #region Archive .. 
-    //private BasicCuboidShape containerShape;
-    //private List<BasicCuboidShape> itemShapes;
-    //private void RunGame() {
-    //  if (containerShape == null)
-    //    return;
-    //  game = new PackingGame(this);
-    //  game.InitializeContainer(containerShape);
-    //  foreach (BasicCuboidShape shape in itemShapes)
-    //    game.AddItemToContainer(shape);
-    //  game.Run(this);
-    //}
-    #endregion
-
-
-
     public void InitializeContainer(float width, float height, float depth) {
       //if (game != null) {
@@ -95,5 +78,5 @@
 
     public void AddItemToContainer(float width, float height, float depth, float x, float y, float z, int itemNr) {
-      AddItemToContainer(width, height, depth, x,y,z, itemNr, 0);
+      AddItemToContainer(width, height, depth, x, y, z, itemNr, 0);
     }
     public void AddItemToContainer(float width, float height, float depth, float x, float y, float z, int itemNr, int material) {
Index: branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/PackingPlan3D.resx
===================================================================
--- branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/PackingPlan3D.resx	(revision 13161)
+++ 	(revision )
@@ -1,120 +1,0 @@
-﻿<?xml version="1.0" encoding="utf-8"?>
-<root>
-  <!-- 
-    Microsoft ResX Schema 
-    
-    Version 2.0
-    
-    The primary goals of this format is to allow a simple XML format 
-    that is mostly human readable. The generation and parsing of the 
-    various data types are done through the TypeConverter classes 
-    associated with the data types.
-    
-    Example:
-    
-    ... ado.net/XML headers & schema ...
-    <resheader name="resmimetype">text/microsoft-resx</resheader>
-    <resheader name="version">2.0</resheader>
-    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
-    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
-    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
-    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
-    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
-        <value>[base64 mime encoded serialized .NET Framework object]</value>
-    </data>
-    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
-        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
-        <comment>This is a comment</comment>
-    </data>
-                
-    There are any number of "resheader" rows that contain simple 
-    name/value pairs.
-    
-    Each data row contains a name, and value. The row also contains a 
-    type or mimetype. Type corresponds to a .NET class that support 
-    text/value conversion through the TypeConverter architecture. 
-    Classes that don't support this are serialized and stored with the 
-    mimetype set.
-    
-    The mimetype is used for serialized objects, and tells the 
-    ResXResourceReader how to depersist the object. This is currently not 
-    extensible. For a given mimetype the value must be set accordingly:
-    
-    Note - application/x-microsoft.net.object.binary.base64 is the format 
-    that the ResXResourceWriter will generate, however the reader can 
-    read any of the formats listed below.
-    
-    mimetype: application/x-microsoft.net.object.binary.base64
-    value   : The object must be serialized with 
-            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
-            : and then encoded with base64 encoding.
-    
-    mimetype: application/x-microsoft.net.object.soap.base64
-    value   : The object must be serialized with 
-            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
-            : and then encoded with base64 encoding.
-
-    mimetype: application/x-microsoft.net.object.bytearray.base64
-    value   : The object must be serialized into a byte array 
-            : using a System.ComponentModel.TypeConverter
-            : and then encoded with base64 encoding.
-    -->
-  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
-    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
-    <xsd:element name="root" msdata:IsDataSet="true">
-      <xsd:complexType>
-        <xsd:choice maxOccurs="unbounded">
-          <xsd:element name="metadata">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" />
-              </xsd:sequence>
-              <xsd:attribute name="name" use="required" type="xsd:string" />
-              <xsd:attribute name="type" type="xsd:string" />
-              <xsd:attribute name="mimetype" type="xsd:string" />
-              <xsd:attribute ref="xml:space" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="assembly">
-            <xsd:complexType>
-              <xsd:attribute name="alias" type="xsd:string" />
-              <xsd:attribute name="name" type="xsd:string" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="data">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
-                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
-              </xsd:sequence>
-              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
-              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
-              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
-              <xsd:attribute ref="xml:space" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="resheader">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
-              </xsd:sequence>
-              <xsd:attribute name="name" type="xsd:string" use="required" />
-            </xsd:complexType>
-          </xsd:element>
-        </xsd:choice>
-      </xsd:complexType>
-    </xsd:element>
-  </xsd:schema>
-  <resheader name="resmimetype">
-    <value>text/microsoft-resx</value>
-  </resheader>
-  <resheader name="version">
-    <value>2.0</value>
-  </resheader>
-  <resheader name="reader">
-    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-  <resheader name="writer">
-    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-</root>
Index: branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/VertexPositionColorNormal.cs
===================================================================
--- branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/VertexPositionColorNormal.cs	(revision 13161)
+++ branches/HeuristicLab.BinPacking/PackingPlanVisualizations/3D/VertexPositionColorNormal.cs	(revision 13465)
@@ -24,5 +24,5 @@
 using SharpDX.Toolkit.Graphics;
 
-namespace PackingPlanVisualizations {               
+namespace PackingPlanVisualizations {
 
   [Serializable]
@@ -50,5 +50,5 @@
 
     public override bool Equals(object obj) {
-      if (obj.GetType() == typeof (VertexPositionColorNormal))
+      if (obj is VertexPositionColorNormal)
         return this.Equals((VertexPositionColorNormal)obj);
       else
Index: branches/HeuristicLab.BinPacking/PackingPlanVisualizations/PackingPlanVisualizations.csproj
===================================================================
--- branches/HeuristicLab.BinPacking/PackingPlanVisualizations/PackingPlanVisualizations.csproj	(revision 13161)
+++ branches/HeuristicLab.BinPacking/PackingPlanVisualizations/PackingPlanVisualizations.csproj	(revision 13465)
@@ -107,12 +107,4 @@
   </ItemGroup>
   <ItemGroup>
-    <EmbeddedResource Include="3D\PackingPlan3D.resx">
-      <DependentUpon>PackingPlan3D.cs</DependentUpon>
-    </EmbeddedResource>
-    <EmbeddedResource Include="2D\PackingPlan2D.resx">
-      <DependentUpon>PackingPlan2D.cs</DependentUpon>
-    </EmbeddedResource>
-  </ItemGroup>
-  <ItemGroup>
     <None Include="HeuristicLab.snk" />
   </ItemGroup>