Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/HeuristicLab.Problems.BinPacking.Views-3.3.csproj
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/HeuristicLab.Problems.BinPacking.Views-3.3.csproj	(revision 13465)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/HeuristicLab.Problems.BinPacking.Views-3.3.csproj	(revision 13466)
@@ -199,5 +199,4 @@
     </ProjectReference>
   </ItemGroup>
-  <ItemGroup />
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/PackingPlans/PackingPlan2DView.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/PackingPlans/PackingPlan2DView.cs	(revision 13465)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/PackingPlans/PackingPlan2DView.cs	(revision 13466)
@@ -35,5 +35,5 @@
     public PackingPlan2DView() {
       InitializeComponent();
-    }       
+    }
 
     protected override void DeregisterContentEvents() {
@@ -57,18 +57,18 @@
       binSelection.Items.Clear();
       if (Content == null) {
-        Redraw();
+        ClearState();
       } else {
         for (int i = 0; i < Content.NrOfBins; i++)
           binSelection.Items.Add(i);
-        Redraw(Content);
+        UpdateState(Content);
       }
     }
 
 
-    private void Redraw() {
+    private void ClearState() {
       packingPlan2D.InitializeContainer(0, 0);
     }
 
-    private void Redraw(PackingPlan<TwoDimensionalPacking, RectangularPackingBin, RectangularPackingItem> plan) {     
+    private void UpdateState(PackingPlan<TwoDimensionalPacking, RectangularPackingBin, RectangularPackingItem> plan) {     
       int currentBin = (binSelection != null && binSelection.SelectedItem != null) ? (int)(binSelection.SelectedItem) : 0;
       var bin = plan.BinPackings[currentBin].BinMeasures;
@@ -84,5 +84,5 @@
 
     private void binSelection_SelectedIndexChanged(object sender, EventArgs e) {
-      Redraw(Content);
+      UpdateState(Content);
       packingPlan2D.Refresh();
     }
@@ -96,9 +96,9 @@
         binSelection.Items.Clear();
         if (Content == null) {
-          Redraw();
+          ClearState();
         } else {
           for (int i = 0; i < Content.NrOfBins; i++)
             binSelection.Items.Add(i);
-          Redraw(Content);
+          UpdateState(Content);
         }
         packingPlan2D.Refresh();
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/CuboidPackingItemView.Designer.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/CuboidPackingItemView.Designer.cs	(revision 13465)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/CuboidPackingItemView.Designer.cs	(revision 13466)
@@ -48,26 +48,22 @@
     /// </summary>
     private void InitializeComponent() {
-      this.packingPlan3D1 = new PackingPlanVisualizations.PackingPlan3D();
+      this.packingPlan3D = new PackingPlanVisualizations.PackingPlan3D();
       this.SuspendLayout();
       // 
-      // packingPlan3D1
+      // packingPlan3D
       // 
-      this.packingPlan3D1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.packingPlan3D1.Location = new System.Drawing.Point(6, 20);
-      this.packingPlan3D1.Name = "packingPlan3D1";
-      this.packingPlan3D1.Size = new System.Drawing.Size(342, 276);
-      this.packingPlan3D1.TabIndex = 3;
+      this.packingPlan3D.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.packingPlan3D.Location = new System.Drawing.Point(0, 0);
+      this.packingPlan3D.Name = "packingPlan3D";
+      this.packingPlan3D.Size = new System.Drawing.Size(351, 299);
+      this.packingPlan3D.TabIndex = 3;
       // 
-      // CuboidPackingShapeView
+      // CuboidPackingItemView
       // 
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
-      this.Controls.Add(this.packingPlan3D1);
-      this.Name = "CuboidPackingShapeView";
+      this.Controls.Add(this.packingPlan3D);
+      this.Name = "CuboidPackingItemView";
       this.Size = new System.Drawing.Size(351, 299);
-      this.Controls.SetChildIndex(this.packingPlan3D1, 0);
       this.ResumeLayout(false);
-      this.PerformLayout();
 
     }
@@ -75,5 +71,5 @@
     #endregion
 
-    private PackingPlanVisualizations.PackingPlan3D packingPlan3D1;
+    private PackingPlanVisualizations.PackingPlan3D packingPlan3D;
 
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/CuboidPackingItemView.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/CuboidPackingItemView.cs	(revision 13465)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/CuboidPackingItemView.cs	(revision 13466)
@@ -43,15 +43,15 @@
       } else {
         Redraw(Content);
-        packingPlan3D1.StartRendering();
+        packingPlan3D.StartRendering();
       }
     }
 
     private void Redraw() {
-      packingPlan3D1.InitializeContainer(0, 0, 0);
+      packingPlan3D.InitializeContainer(0, 0, 0);
     }
 
     private void Redraw(CuboidPackingItem item) {
-      packingPlan3D1.InitializeContainer(item.TargetBin.Width, item.TargetBin.Height, item.TargetBin.Depth);
-      packingPlan3D1.AddItemToContainer(item.Width, item.Height, item.Depth, 0, 0, 0, 0);
+      packingPlan3D.InitializeContainer(item.TargetBin.Width, item.TargetBin.Height, item.TargetBin.Depth);
+      packingPlan3D.AddItemToContainer(item.Width, item.Height, item.Depth, 0, 0, 0, 0);
     }
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/CuboidPackingShapeView.Designer.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/CuboidPackingShapeView.Designer.cs	(revision 13465)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/CuboidPackingShapeView.Designer.cs	(revision 13466)
@@ -48,26 +48,22 @@
     /// </summary>
     private void InitializeComponent() {
-      this.packingPlan3D1 = new PackingPlanVisualizations.PackingPlan3D();
+      this.packingPlan3D = new PackingPlanVisualizations.PackingPlan3D();
       this.SuspendLayout();
       // 
-      // packingPlan3D1
+      // packingPlan3D
       // 
-      this.packingPlan3D1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.packingPlan3D1.Location = new System.Drawing.Point(6, 20);
-      this.packingPlan3D1.Name = "packingPlan3D1";
-      this.packingPlan3D1.Size = new System.Drawing.Size(342, 276);
-      this.packingPlan3D1.TabIndex = 3;
+      this.packingPlan3D.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.packingPlan3D.Location = new System.Drawing.Point(0, 0);
+      this.packingPlan3D.Name = "packingPlan3D";
+      this.packingPlan3D.Size = new System.Drawing.Size(351, 299);
+      this.packingPlan3D.TabIndex = 3;
       // 
       // CuboidPackingShapeView
       // 
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
-      this.Controls.Add(this.packingPlan3D1);
+      this.Controls.Add(this.packingPlan3D);
       this.Name = "CuboidPackingShapeView";
       this.Size = new System.Drawing.Size(351, 299);
-      this.Controls.SetChildIndex(this.packingPlan3D1, 0);
       this.ResumeLayout(false);
-      this.PerformLayout();
 
     }
@@ -75,5 +71,5 @@
     #endregion
 
-    private PackingPlanVisualizations.PackingPlan3D packingPlan3D1;
+    private PackingPlanVisualizations.PackingPlan3D packingPlan3D;
 
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/CuboidPackingShapeView.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/CuboidPackingShapeView.cs	(revision 13465)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/CuboidPackingShapeView.cs	(revision 13466)
@@ -43,14 +43,14 @@
       } else {
         Redraw(Content);
-        packingPlan3D1.StartRendering();
+        packingPlan3D.StartRendering();
       }
     }
 
     private void Redraw() {
-      packingPlan3D1.InitializeContainer(0, 0, 0);
+      packingPlan3D.InitializeContainer(0, 0, 0);
     }
 
     private void Redraw(CuboidPackingShape shape) {
-      packingPlan3D1.InitializeContainer(shape.Width, shape.Height, shape.Depth);
+      packingPlan3D.InitializeContainer(shape.Width, shape.Height, shape.Depth);
     }
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/RectangularPackingItemView.Designer.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/RectangularPackingItemView.Designer.cs	(revision 13465)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/RectangularPackingItemView.Designer.cs	(revision 13466)
@@ -50,21 +50,17 @@
       // packingPlan2D
       // 
-      this.packingPlan2D.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.packingPlan2D.Location = new System.Drawing.Point(3, 29);
+      this.packingPlan2D.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.packingPlan2D.Location = new System.Drawing.Point(0, 0);
       this.packingPlan2D.Name = "packingPlan2D";
-      this.packingPlan2D.Size = new System.Drawing.Size(345, 270);
+      this.packingPlan2D.Size = new System.Drawing.Size(351, 299);
       this.packingPlan2D.TabIndex = 4;
       // 
-      // PackingPlanView
+      // RectangularPackingItemView
       // 
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
       this.Controls.Add(this.packingPlan2D);
-      this.Name = "PackingPlanView";
+      this.Name = "RectangularPackingItemView";
       this.Size = new System.Drawing.Size(351, 299);
-      this.Controls.SetChildIndex(this.packingPlan2D, 0);
       this.ResumeLayout(false);
-      this.PerformLayout();
 
     }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/RectangularPackingItemView.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/RectangularPackingItemView.cs	(revision 13465)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/RectangularPackingItemView.cs	(revision 13466)
@@ -40,15 +40,15 @@
       base.OnContentChanged();
       if (Content == null) {
-        Redraw();
+        ClearState();
       } else {
-        Redraw(Content);
+        UpdateState(Content);
       }
     }
 
-    private void Redraw() {
+    private void ClearState() {
       packingPlan2D.InitializeContainer(0, 0);
     }
 
-    private void Redraw(RectangularPackingItem item) {
+    private void UpdateState(RectangularPackingItem item) {
       packingPlan2D.InitializeContainer(item.TargetBin.Width, item.TargetBin.Height);
       packingPlan2D.AddItemToContainer(item.Width, item.Height, 0, 0, "0");
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/RectangularPackingShapeView.Designer.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/RectangularPackingShapeView.Designer.cs	(revision 13465)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/RectangularPackingShapeView.Designer.cs	(revision 13466)
@@ -50,21 +50,17 @@
       // packingPlan2D
       // 
-      this.packingPlan2D.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.packingPlan2D.Location = new System.Drawing.Point(3, 29);
+      this.packingPlan2D.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.packingPlan2D.Location = new System.Drawing.Point(0, 0);
       this.packingPlan2D.Name = "packingPlan2D";
-      this.packingPlan2D.Size = new System.Drawing.Size(345, 270);
+      this.packingPlan2D.Size = new System.Drawing.Size(351, 299);
       this.packingPlan2D.TabIndex = 4;
       // 
-      // PackingPlanView
+      // RectangularPackingShapeView
       // 
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
       this.Controls.Add(this.packingPlan2D);
-      this.Name = "PackingPlanView";
+      this.Name = "RectangularPackingShapeView";
       this.Size = new System.Drawing.Size(351, 299);
-      this.Controls.SetChildIndex(this.packingPlan2D, 0);
       this.ResumeLayout(false);
-      this.PerformLayout();
 
     }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/RectangularPackingShapeView.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/RectangularPackingShapeView.cs	(revision 13465)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Shapes/RectangularPackingShapeView.cs	(revision 13466)
@@ -40,16 +40,15 @@
       base.OnContentChanged();
       if (Content == null) {
-        Redraw();
+        ClearState();
       } else {
-        Redraw(Content);
+        UpdateState(Content);
       }
     }
 
-
-    private void Redraw() {
+    private void ClearState() {
       packingPlan2D.InitializeContainer(0, 0);
     }
 
-    private void Redraw(RectangularPackingShape shape) {
+    private void UpdateState(RectangularPackingShape shape) {
       packingPlan2D.InitializeContainer(shape.Width, shape.Height);
     }