Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/PackingPlans/PackingPlan2DView.Designer.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/PackingPlans/PackingPlan2DView.Designer.cs	(revision 13467)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/PackingPlans/PackingPlan2DView.Designer.cs	(revision 13468)
@@ -54,7 +54,7 @@
             | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
-      this.packingPlan2D.Location = new System.Drawing.Point(67, 26);
+      this.packingPlan2D.Location = new System.Drawing.Point(67, 3);
       this.packingPlan2D.Name = "packingPlan2D";
-      this.packingPlan2D.Size = new System.Drawing.Size(281, 264);
+      this.packingPlan2D.Size = new System.Drawing.Size(383, 340);
       this.packingPlan2D.TabIndex = 3;
       // 
@@ -64,7 +64,7 @@
             | System.Windows.Forms.AnchorStyles.Left)));
       this.binSelection.FormattingEnabled = true;
-      this.binSelection.Location = new System.Drawing.Point(6, 26);
+      this.binSelection.Location = new System.Drawing.Point(6, 3);
       this.binSelection.Name = "binSelection";
-      this.binSelection.Size = new System.Drawing.Size(55, 264);
+      this.binSelection.Size = new System.Drawing.Size(55, 329);
       this.binSelection.TabIndex = 4;
       this.binSelection.SelectedIndexChanged += new System.EventHandler(this.binSelection_SelectedIndexChanged);
@@ -77,9 +77,6 @@
       this.Controls.Add(this.packingPlan2D);
       this.Name = "PackingPlan2DView";
-      this.Size = new System.Drawing.Size(351, 299);
-      this.Controls.SetChildIndex(this.packingPlan2D, 0);
-      this.Controls.SetChildIndex(this.binSelection, 0);
+      this.Size = new System.Drawing.Size(453, 346);
       this.ResumeLayout(false);
-      this.PerformLayout();
 
     }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/PackingPlans/PackingPlan3DView.Designer.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/PackingPlans/PackingPlan3DView.Designer.cs	(revision 13467)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/PackingPlans/PackingPlan3DView.Designer.cs	(revision 13468)
@@ -55,7 +55,7 @@
             | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
-      this.packingPlan3D.Location = new System.Drawing.Point(119, 26);
+      this.packingPlan3D.Location = new System.Drawing.Point(119, 3);
       this.packingPlan3D.Name = "packingPlan3D";
-      this.packingPlan3D.Size = new System.Drawing.Size(229, 264);
+      this.packingPlan3D.Size = new System.Drawing.Size(229, 293);
       this.packingPlan3D.TabIndex = 3;
       // 
@@ -65,7 +65,7 @@
             | System.Windows.Forms.AnchorStyles.Left)));
       this.binSelection.FormattingEnabled = true;
-      this.binSelection.Location = new System.Drawing.Point(6, 26);
+      this.binSelection.Location = new System.Drawing.Point(3, 3);
       this.binSelection.Name = "binSelection";
-      this.binSelection.Size = new System.Drawing.Size(54, 264);
+      this.binSelection.Size = new System.Drawing.Size(54, 290);
       this.binSelection.TabIndex = 4;
       this.binSelection.SelectedIndexChanged += new System.EventHandler(this.binSelection_SelectedIndexChanged);
@@ -76,7 +76,7 @@
             | System.Windows.Forms.AnchorStyles.Left)));
       this.itemSelection.FormattingEnabled = true;
-      this.itemSelection.Location = new System.Drawing.Point(58, 26);
+      this.itemSelection.Location = new System.Drawing.Point(58, 3);
       this.itemSelection.Name = "itemSelection";
-      this.itemSelection.Size = new System.Drawing.Size(55, 264);
+      this.itemSelection.Size = new System.Drawing.Size(55, 290);
       this.itemSelection.TabIndex = 5;
       this.itemSelection.SelectedIndexChanged += new System.EventHandler(this.itemSelection_SelectedIndexChanged);
@@ -91,9 +91,5 @@
       this.Name = "PackingPlan3DView";
       this.Size = new System.Drawing.Size(351, 299);
-      this.Controls.SetChildIndex(this.packingPlan3D, 0);
-      this.Controls.SetChildIndex(this.binSelection, 0);
-      this.Controls.SetChildIndex(this.itemSelection, 0);
       this.ResumeLayout(false);
-      this.PerformLayout();
 
     }
Index: /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/CenteredContainer2D.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/CenteredContainer2D.cs	(revision 13467)
+++ /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/CenteredContainer2D.cs	(revision 13468)
@@ -28,8 +28,10 @@
     private Vector2 containerSize;
     private Vector2 controlSize;
-    private float normalizingFactor;
+    private float xScaling;
+    private float yScaling;
+    private readonly List<PackingItem> packingItems = new List<PackingItem>();
 
-    public Vector2 ContainerCenter { 
-      get { return new Vector2(controlSize.X / 2, controlSize.Y / 2); } 
+    public Vector2 ContainerCenter {
+      get { return new Vector2(controlSize.X / 2, controlSize.Y / 2); }
     }
 
@@ -37,16 +39,16 @@
       private Vector2 position;
       private Vector2 size;
-      private string label;
-      public PackingItem(Vector2 size, Vector2 position, string label, CenteredContainer2D parentContainer) {
+      private readonly string label;
+      public PackingItem(Vector2 size, Vector2 position, string label) {
         this.size = size;
         this.position = position;
         this.label = label;
       }
-      public RectangleF GetRectangle(Vector2 topLeft, float normalizingFactor) {
+      public RectangleF GetRectangle(Vector2 topLeft, float sx, float sy) {
         return new RectangleF(
-          topLeft.X  + position.X * normalizingFactor + 2,
-          topLeft.Y  + position.Y * normalizingFactor + 2,
-          topLeft.X  + position.X * normalizingFactor + size.X * normalizingFactor - 2,
-          topLeft.Y  + position.Y * normalizingFactor + size.Y * normalizingFactor - 2
+          topLeft.X + position.X * sx + 2,
+          topLeft.Y + position.Y * sy + 2,
+          topLeft.X + position.X * sx + size.X * sx - 2,
+          topLeft.Y + position.Y * sy + size.Y * sy - 2
         );
       }
@@ -55,41 +57,27 @@
       }
     }
-    private List<PackingItem> packingItems = new List<PackingItem>();
 
-    //public struct LabelStructure {
-    //  private string text;
-    //  public string Text { get { return text; } }
-    //  private RectangleF layoutRect;
-    //  public RectangleF LayoutRectangle { get { return layoutRect; } }
-    //  public LabelStructure(string text, RectangleF layout) {
-    //    this.text = text;
-    //    this.layoutRect = layout;
-    //  }
-    //}
-        
-    public CenteredContainer2D (Vector2 controlSize, Vector2 containerSize) {
+    public CenteredContainer2D(Vector2 controlSize, Vector2 containerSize) {
       this.containerSize = containerSize;
       UpdateContainer(controlSize);
     }
-    public CenteredContainer2D(float controlWidth, float controlHeight, float containerWidth, float containerHeight) 
-      : this(new Vector2 (controlWidth, controlHeight), new Vector2(containerWidth, containerHeight)) { 
+    public CenteredContainer2D(float controlWidth, float controlHeight, float containerWidth, float containerHeight)
+      : this(new Vector2(controlWidth, controlHeight), new Vector2(containerWidth, containerHeight)) {
     }
 
     public void AddItem(Vector2 size, Vector2 position, string label) {
-      packingItems.Add(new PackingItem (size, position, label, this));
+      packingItems.Add(new PackingItem(size, position, label));
     }
     public void AddItem(float width, float height, float x, float y, string label) {
-      AddItem(new Vector2 (width, height), new Vector2 (x, y), label);
+      AddItem(new Vector2(width, height), new Vector2(x, y), label);
     }
-     
+
     public void UpdateContainer(Vector2 controlSize) {
       this.controlSize = controlSize;
-      if (controlSize.X / controlSize.Y > containerSize.X / containerSize.Y)
-        this.normalizingFactor = controlSize.Y / (containerSize.Y + 5);
-      else if (controlSize.X / controlSize.Y <= containerSize.X / containerSize.Y)
-        this.normalizingFactor = controlSize.X / (containerSize.X + 5);
+      xScaling = controlSize.X / (containerSize.X + 5);
+      yScaling = controlSize.Y / (containerSize.Y + 5);
     }
     public void UpdateContainer(float controlWidth, float controlHeight) {
-      UpdateContainer(new Vector2 (controlWidth, controlHeight));
+      UpdateContainer(new Vector2(controlWidth, controlHeight));
     }
 
@@ -98,8 +86,8 @@
       //Compute centered rectangle
       SharpDX.RectangleF result = new SharpDX.RectangleF(
-        ContainerCenter.X - containerSize.X * normalizingFactor / 2 - 2,
-        ContainerCenter.Y - containerSize.Y * normalizingFactor / 2 - 2,
-        ContainerCenter.X + containerSize.X * normalizingFactor / 2 + 2,
-        ContainerCenter.Y + containerSize.Y * normalizingFactor / 2 + 2);
+        ContainerCenter.X - containerSize.X * xScaling / 2 - 2,
+        ContainerCenter.Y - containerSize.Y * yScaling / 2 - 2,
+        ContainerCenter.X + containerSize.X * xScaling / 2 + 2,
+        ContainerCenter.Y + containerSize.Y * yScaling / 2 + 2);
 
       return result;
@@ -115,11 +103,12 @@
       }
     }
+
     public List<LabeledRectangle> GetItemRectangles() {
-      List<LabeledRectangle> result = new List<LabeledRectangle> ();
+      List<LabeledRectangle> result = new List<LabeledRectangle>();
 
       foreach (PackingItem item in packingItems) {
-        result.Add(new LabeledRectangle(item.GetLabel(), item.GetRectangle(new Vector2(
-          ContainerCenter.X - containerSize.X * normalizingFactor / 2,
-          ContainerCenter.Y - containerSize.Y * normalizingFactor / 2), normalizingFactor)));
+        result.Add(new LabeledRectangle(item.GetLabel(),
+          item.GetRectangle(new Vector2(ContainerCenter.X - containerSize.X * xScaling / 2,
+                                        ContainerCenter.Y - containerSize.Y * yScaling / 2), xScaling, yScaling)));
       }
 
Index: /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/PackingPlan2D.Designer.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/PackingPlan2D.Designer.cs	(revision 13467)
+++ /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/PackingPlan2D.Designer.cs	(revision 13468)
@@ -53,7 +53,7 @@
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.Name = "PackingPlan2D";
+      this.Size = new System.Drawing.Size(163, 150);
       this.Load += new System.EventHandler(this.PackingPlan2D_Load);
       this.Paint += new System.Windows.Forms.PaintEventHandler(this.PackingPlan2D_Paint);
-      this.MouseClick += new System.Windows.Forms.MouseEventHandler(this.PackingPlan2D_MouseClick);
       this.Resize += new System.EventHandler(this.PackingPlan2D_Resize);
       this.ResumeLayout(false);
Index: /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/PackingPlan2D.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/PackingPlan2D.cs	(revision 13467)
+++ /branches/HeuristicLab.BinPacking/PackingPlanVisualizations/2D/PackingPlan2D.cs	(revision 13468)
@@ -121,7 +121,4 @@
     }
 
-    private void PackingPlan2D_MouseClick(object sender, MouseEventArgs e) {
-      Console.WriteLine(e.X + " - " + e.Y);
-    }
   }
 }